<?php

/**
 * @property $disciplines_collection  Model_Disciplines
 */

class Controller_Office_Disciplines extends Controller_Environment_Office {

    public function before() {
        parent::before();
        $this->user->checkAccess(User::RIGHTS_DEAN | User::RIGHTS_ADMIN);
        $this->disciplines_collection = new Model_Disciplines();
    }

    public function action_index() {
        $gradeID = $this->request->query('gradeID');
        $this->show_data(null, $gradeID);

    }

    public function action_filter() {
        $this->show_data($this->request->param('parameter'), null);
    }

    private function show_data($state, $gradeID, $semesterID = null){
        $semesterID = $semesterID ?: User::instance()->SemesterID;
        $facultyID = $this->user->Faculty->ID;
        $grades = Model_Grades::loadAll()->as_array();
        $grade = $grades[$gradeID];
        $parameters = ['semesterID' => $semesterID, 'facultyID' => $facultyID, 'gradenum' => $grade["Num"], 'degree' => $grade["Degree"]];
        $disciplines = $this->disciplines_collection->setParamValues($parameters)
                                                    ->getByState($state);
        $teachers = [];
        foreach ($disciplines as $discipline) {
            $teachers[$discipline['ID']] = Model_Teacher::with($discipline['AuthorID']);
        }

        $inMainList = $state === null;
        $this->twig->set_filename(self::OFFICE . 'disciplines/index')
            ->set([
                'Disciplines' => $disciplines,
                'Teachers'    => $teachers,
                'InMainList'  => $inMainList
            ]);

    }
}
